package com.telepathicgrunt.the_bumblezone.entities.goals;

import com.telepathicgrunt.the_bumblezone.entities.controllers.HoneySlimeMoveController;
import com.telepathicgrunt.the_bumblezone.entities.mobs.HoneySlimeEntity;
import net.minecraft.world.entity.ai.goal.Goal;
import net.minecraft.world.entity.ai.goal.target.HurtByTargetGoal;

import java.util.EnumSet;

public class HoneySlimeRevengeGoal extends HurtByTargetGoal {
    private final HoneySlimeEntity slime;

    public HoneySlimeRevengeGoal(HoneySlimeEntity slimeIn) {
        super(slimeIn);
        this.slime = slimeIn;
        this.setFlags(EnumSet.of(Goal.Flag.LOOK));
    }

    public boolean canContinueToUse() {
        return slime.getTarget() != null && super.canContinueToUse();
    }

    public void tick() {
        if (this.slime.isPassenger()) {
            return;
        }
        if(this.slime.getTarget() != null) {
            this.slime.lookAt(this.slime.getTarget(), 10.0F, 10.0F);
        }
        ((HoneySlimeMoveController) this.slime.getMoveControl()).setDirection(this.slime.getYRot(), this.slime.canDamagePlayer());
    }
}